<div align="center">
<img src="../images/talan_meet_logo.png" >


<br>💻📱👔💼
<br>
**Noise reduction using Dual-signal Transformation LSTM Network**
</div>

## Description 📝
A Dual-signal Transformation LSTM Network (DTLN) is trained to take a noisy signal (a speech sound with some noise) and tries to output a clean representation of it.
<br>For more details about DTLN and it's use for real-time noise suppression, visit <a href="https://github.com/breizhn/DTLN">this github repository.</a>
## Content 🛠

*  **Training.ipynb** \
  A notebook to run the training. <br>
* **Predict.ipynb** \
  A notebook to use the trained model to reduce noise from a new speech sound sample.<br>
+  **./pretrained_model/** 
   * `model.h5`: Model weights as used in the DNS-Challenge DTLN model.
   * `DTLN_norm_500h.h5`: Model weights trained on 500h with normalization of stft log magnitudes.
   * `DTLN_norm_40h.h5`: Model weights trained on 40h with normalization of stft log magnitudes.
   * `./dtln_saved_model`: same as `model.h5` but as a stateful model in SavedModel format.
   * `./DTLN_norm_500h_saved_model`: same as `DTLN_norm_500h.h5` but as a stateful model in SavedModel format.
   * `./DTLN_norm_40h_saved_model`: same as `DTLN_norm_40h.h5` but as a stateful model in SavedModel format.
   * `model_1.tflite` together with `model_2.tflite`: same as `model.h5` but as TF-lite model with external state handling.
   * `model_quant_1.tflite` together with `model_quant_2.tflite`: same as `model.h5` but as TF-lite model with external state handling and dynamic range quantization.
   * `model_1.onnx` together with `model_2.onnx`: same as `model.h5` but as ONNX model with external state handling.
+  **./DTLN_js/** 
    * `group1-shard1of1.bin`: Model weight file in binary format.
    * `model.json` :  File contains the model topology ("architecture" or "graph": a description of the layers and how they are connected).
## Dependencies ⚙️ 
The following packages are required:

- TensorFlow (2.x)
- librosa
- wavinfo

These packages can be installed in the command line using `pip` or by creating an anaconda environment using train_env.yml file via this command:<br>
```
$ conda env create -f train_env.yml
```
## Dataset 🔊
to build our noisy speech dataset thousands of hours of synthetic noisy speech were generated by combining random noises (dog barking, door slamming, street noises, etc..) with clean voices. The Mozilla Common Voice dataset which is a corpus of speech data read by usersbased upon text from several public domain sources like user submitted blog posts, old books and movies is used as the clean speech data. Also, urbanSound8k dataset that contains 8732 labeled sound excerptsof urban sounds from 10 classes(air conditioner, car-horn, children-playing, dog-bark, drilling, engine-idling, siren, and street-music) is used as noise signals.
To generate the noisy speech dataset random spoken sentences from the Mozilla dataset are combined with noisy sounds such a dog barking from urbanSound8k dataset.
## Demo 📸
To test the trained model, visit <a href="https://talan_innovation_factory.gitlab.io/artificial-intelligence/noisereductiondemopage/"> this link</a> .
## refrences 📓
- **paper**: http://dx.doi.org/10.21437/Interspeech.2020-2631
- **"breizhn" DTLN github repository**: https://github.com/breizhn/DTLN
  
